
#include "stdafx.h"
#include "demo_interface_sink.h"

ADTF_PLUGIN("Demo Interface Sink",
            InterfaceSink);


InterfaceSink::InterfaceSink()
{

}
tResult InterfaceSink::Construct()
{
    RETURN_IF_FAILED(cSampleStreamingSink::Construct());

    RETURN_IF_FAILED(create_client<IPrintInterface>(*this, "printer_client"));
	RETURN_NOERROR;
}

tResult InterfaceSink::Init()
{
    //RETURN_IF_FAILED(FindBindingObject("printer_client", m_pBindingClient));
    //object_ptr<IPrintInterface> pPrinter;
    //if (IS_OK(m_pBindingClient->GetServerObject(pPrinter)))
    //{
    //    pPrinter->Print(adtf_util::cString::Format(" this is streaming sink"));
    //}
    RETURN_NOERROR;
}

tResult InterfaceSink::StartStreaming()
{
    RETURN_IF_FAILED(FindBindingObject("printer_client", m_pBindingClient));
    object_ptr<IPrintInterface> pPrinter;
    //the next line will fail
    if (IS_OK(m_pBindingClient->GetServerObject(pPrinter)))
    {
        pPrinter->Print(adtf_util::cString::Format("this is streaming sink"));
    }
    else
    {
        LOG_INFO("failed to get binding server for printer_client");
    }
    RETURN_NOERROR;
}


